Index: src/Fl_Browser.cxx
===================================================================
--- src/Fl_Browser.cxx	(revision 6732)
+++ src/Fl_Browser.cxx	(working copy)
@@ -835,6 +835,64 @@
   swap(ai,bi);
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+long
+Fl_Browser::msaa_browser_size()
+{
+  return size();
+}
+
+
+bool
+Fl_Browser::msaa_browser_displayed(long id)
+{
+  return displayed(id);
+}
+
+
+bool
+Fl_Browser::msaa_browser_selected(long id)
+{
+  return selected(id);
+}
+
+
+long 
+Fl_Browser::msaa_browser_find_item(void* l)
+{
+  return lineno(l);
+}
+
+
+long
+Fl_Browser::msaa_browser_focus()
+{
+  return value();
+}
+
+
+void
+Fl_Browser::msaa_browser_set_focus(long id)
+{
+  select(id, selected(id));
+  display(id);
+}
+
+
+bool
+Fl_Browser::msaa_browser_text(long id, BSTR* bstr)
+{
+  fl_str_to_bstr(text(id), -1, bstr);
+  return true;
+}
+#endif // FL_HAVE_MSAA
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Tabs.cxx
===================================================================
--- src/Fl_Tabs.cxx	(revision 6732)
+++ src/Fl_Tabs.cxx	(working copy)
@@ -285,6 +285,9 @@
       o->hide();
     }
   }
+#ifdef FL_HAVE_MSAA
+  if (ret && (Fl::focus() == this))  msaa_on_focus();
+#endif // FL_HAVE_MSAA
   return ret;
 }
 
@@ -420,8 +423,585 @@
 {
   box(FL_THIN_UP_BOX);
   push_ = 0;
+#ifdef FL_HAVE_MSAA
+  // Initialize MSAA stuff
+  msaa_tabs_proxy_ = 0;
+#endif // FL_HAVE_MSAA
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+#include <FL/x.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+#define CID_TABS	1
+
+
+class Fl_Msaa_Tabs_Proxy : public Fl_Msaa_Proxy
+{
+public:
+  Fl_Msaa_Tabs_Proxy(Fl_Widget* o) : Fl_Msaa_Proxy(o)  {}
+  long LookupChild(Fl_Widget* o)  {return -1;}
+
+  // IAccessible implementation
+  HRESULT STDMETHODCALLTYPE get_accParent(IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accChildCount(long*);
+  HRESULT STDMETHODCALLTYPE get_accChild(VARIANT, IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accName(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accValue(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accDescription(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accRole(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accState(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accHelp(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accHelpTopic(BSTR*, VARIANT, long*);
+  HRESULT STDMETHODCALLTYPE get_accKeyboardShortcut(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accFocus(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accSelection(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accDefaultAction(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE accSelect(long, VARIANT);
+  HRESULT STDMETHODCALLTYPE accLocation(long*, long*, long*, long*, VARIANT);
+  HRESULT STDMETHODCALLTYPE accNavigate(long, VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accHitTest(long, long, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accDoDefaultAction(VARIANT);
+  HRESULT STDMETHODCALLTYPE put_accValue(VARIANT, BSTR);
+};
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accParent(
+    /* [retval][out] */ IDispatch** ppdispParent)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!ppdispParent)  return E_INVALIDARG;
+  *ppdispParent = NULL;
+
+  // Fl_Msaa_Tabs_Proxy is a child of the widget's proxy
+  Fl_Msaa_Proxy* proxy = tabs->msaa_proxy();
+  if (!proxy)  return S_FALSE;
+  proxy->QueryInterface(IID_IDispatch, (void**)ppdispParent);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accChildCount(
+    /* [retval][out] */ long* pcountChildren)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pcountChildren)  return E_INVALIDARG;
+
+  // Each child widget is represented by a tab
+  *pcountChildren = tabs->children();
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accChild(
+    /* [in] */ VARIANT varChild,
+    /* [retval][out] */ IDispatch** ppdispChild)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (varChild.vt != VT_I4)  return E_INVALIDARG;
+  if (!ppdispChild)  return E_INVALIDARG;
+  *ppdispChild = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  // All tabs are simple elements
+  return S_FALSE;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accName(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszName)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pszName)  return E_INVALIDARG;
+  *pszName = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  if (id && tabs->msaa_tabs_name(id, pszName))  return S_OK;
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszValue)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pszValue)  return E_INVALIDARG;
+  *pszValue = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  // Tabs do not have values
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accDescription(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDescription)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDescription)  return E_INVALIDARG;
+  *pszDescription = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  // Tabs do not have description
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accRole(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarRole)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarRole)  return E_INVALIDARG;
+  pvarRole->vt = VT_EMPTY;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  pvarRole->vt   = VT_I4;
+  pvarRole->lVal = (id ? ROLE_SYSTEM_PAGETAB : ROLE_SYSTEM_PAGETABLIST);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accState(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarState)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarState)  return E_INVALIDARG;
+  pvarState->vt = VT_EMPTY;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  pvarState->vt   = VT_I4;
+  pvarState->lVal = tabs->msaa_tabs_state(id);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accHelp(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszHelp)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelp)  return E_INVALIDARG;
+  *pszHelp = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  if (id && tabs->msaa_tabs_help(id, pszHelp))  return S_OK;
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accHelpTopic(
+    /* [out] */ BSTR* pszHelpFile,
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ long* pidTopic)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelpFile)  return E_INVALIDARG;
+  if (!pidTopic)  return E_INVALIDARG;
+  *pszHelpFile = NULL;
+  *pidTopic = 0;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  // Tabs do not have help topics
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accKeyboardShortcut(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszKeyboardShortcut)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pszKeyboardShortcut)  return E_INVALIDARG;
+  *pszKeyboardShortcut = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  if (id && tabs->msaa_tabs_shortcut(id, pszKeyboardShortcut))  return S_OK;
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accFocus(
+    /* [retval][out] */ VARIANT *pvarChild)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+
+  // Report ID of selected tab
+  if (Fl::focus() != tabs)  return S_OK;
+  int id = tabs->msaa_tabs_selected_id();
+  if (id <= 0)  return S_OK;
+  pvarChild->vt   = VT_I4;
+  pvarChild->lVal = id;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accSelection(
+    /* [retval][out] */ VARIANT* pvarChildren)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChildren)  return E_INVALIDARG;
+  pvarChildren->vt = VT_EMPTY;
+
+  // Tab list do not have selection
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::get_accDefaultAction(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDefaultAction)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDefaultAction)  return E_INVALIDARG;
+  *pszDefaultAction = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  // Switching between tabs is possible
+  if (id == 0)  return DISP_E_MEMBERNOTFOUND;
+  fl_str_to_bstr("Switch", -1, pszDefaultAction);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::accSelect(
+    /* [in] */ long flagsSelect,
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  // Selection is not possible with tab list
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::accLocation(
+    /* [out] */ long* pxLeft,
+    /* [out] */ long* pyTop,
+    /* [out] */ long* pcxWidth,
+    /* [out] */ long* pcyHeight,
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pxLeft || !pyTop || !pcxWidth || !pcyHeight)  return E_INVALIDARG;
+  *pxLeft = *pyTop = *pcxWidth = *pcyHeight = 0;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  if (tabs->msaa_tabs_location(id, pxLeft, pyTop, pcxWidth, pcyHeight))
+    return S_OK;
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::accNavigate(
+    /* [in] */ long navDir,
+    /* [optional][in] */ VARIANT varStart,
+    /* [retval][out] */ VARIANT* pvarEndUpAt)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarEndUpAt)  return E_INVALIDARG;
+  pvarEndUpAt->vt = VT_EMPTY;
+  long id = (varStart.vt == VT_I4 ? varStart.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  // Handle navigation relative to this widget
+  if ((id == 0) &&
+      (navDir != NAVDIR_FIRSTCHILD) && (navDir != NAVDIR_LASTCHILD))
+  {
+    // Forward request to Fl_Tabs widget
+    varStart.vt   = VT_I4;
+    varStart.lVal = CID_TABS;
+    return Fl_Msaa_Proxy::accNavigate(navDir, varStart, pvarEndUpAt);
+  }
+
+  // Handle navigation between tabs
+  long max_id = tabs->children();
+  if (max_id < 1)  return DISP_E_MEMBERNOTFOUND;
+  long dst;
+  switch (navDir)
+  {
+    case NAVDIR_FIRSTCHILD:  dst = 1;  break;
+    case NAVDIR_LASTCHILD:   dst = max_id;  break;
+    case NAVDIR_PREVIOUS:    dst = (id == 1 ? -1 : (id - 1));  break;
+    case NAVDIR_NEXT:	     dst = (id == max_id ? -1 : (id + 1));  break;
+
+    // Spatial navigation not implemented
+    case NAVDIR_UP:	     // Fall through
+    case NAVDIR_DOWN:	     // Fall through
+    case NAVDIR_LEFT:	     // Fall through
+    case NAVDIR_RIGHT:	     // Fall through
+    default:		     dst = -1;  break;
+  }
+  if (dst < 0)  return DISP_E_MEMBERNOTFOUND;
+  pvarEndUpAt->vt   = VT_I4;
+  pvarEndUpAt->lVal = dst;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::accHitTest(
+    /* [in] */ long xLeft,
+    /* [in] */ long yTop,
+    /* [retval][out] */ VARIANT* pvarChild)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+
+  // Make sure the point is inside this widget
+  long X, Y, W, H;
+  if (!tabs->msaa_tabs_location(0, &X, &Y, &W, &H))  return S_FALSE;
+  if ((xLeft < X) || (xLeft >= (X + W)))  return S_FALSE;
+  if ((yTop < Y) || (yTop >= (Y + H)))  return S_FALSE;
+
+  // Check child elements from top to bottom
+  for (int n = tabs->children();  n > 0;  --n)
+  {
+    if (!tabs->msaa_tabs_location(n, &X, &Y, &W, &H))  continue;
+    if ((xLeft < X) || (xLeft >= (X + W)))  continue;
+    if ((yTop < Y) || (yTop >= (Y + H)))  continue;
+
+    // Return child ID
+    pvarChild->vt   = VT_I4;
+    pvarChild->lVal = n;
+    return S_OK;
+  }
+
+  pvarChild->vt   = VT_I4;
+  pvarChild->lVal = 0;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::accDoDefaultAction(
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  // Switch to required tab
+  if (id == 0)  return DISP_E_MEMBERNOTFOUND;
+  tabs->value(tabs->child(id - 1));
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Tabs_Proxy::put_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [in] */ BSTR szValue)
+{
+  Fl_Tabs* tabs = (Fl_Tabs*)mpObj;
+  if (!tabs)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > tabs->children())  return E_INVALIDARG;
+
+  // Tab list does not accept value
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+/*------------------------- Fl_Tabs MSAA support -----------------------*/
+
+void
+Fl_Tabs::msaa_tabs_on_focus(long id)
+{
+  if (Fl::focus() != this)  return;
+  Fl_Msaa_Proxy* proxy = msaa_child(CID_TABS);
+  NotifyWinEvent(EVENT_OBJECT_FOCUS, fl_xid(msaa_window()), (LONG)proxy, id);
+}
+
+
+Fl_Msaa_Proxy*
+Fl_Tabs::msaa_child(long id)
+{
+  if (id != CID_TABS)  return Fl_Group::msaa_child(id);
+
+  // Create specialized proxy for tab list
+  if (!msaa_tabs_proxy_)
+  {
+    msaa_tabs_proxy_ = new Fl_Msaa_Tabs_Proxy(this);
+    if (msaa_tabs_proxy_)  msaa_tabs_proxy_->AddRef();
+  }
+  return msaa_tabs_proxy_;
+}
+
+
+Fl_Widget*
+Fl_Tabs::msaa_child_widget(long id)  const
+{
+  if (id == 0)  return (Fl_Widget*)this;
+  if (id != CID_TABS)  return Fl_Group::msaa_child_widget(id - 1);
+  return NULL;
+}
+
+
+long
+Fl_Tabs::msaa_child_id(Fl_Widget* o) const
+{
+  long id = Fl_Group::msaa_child_id(o);
+  if (id <= 0)  return id;
+  return id + 1;
+}
+
+
+void
+Fl_Tabs::msaa_cleanup()
+{
+  // Destroy custom proxy
+  if (msaa_tabs_proxy_)
+  {
+    msaa_tabs_proxy_->Detach();
+    msaa_tabs_proxy_->Release();
+  }
+
+  // Destroy standard proxy
+  Fl_Group::msaa_cleanup();
+}
+
+
+long
+Fl_Tabs::msaa_tabs_selected_id()
+{
+  for (int n = 0;  n < children();  ++n)
+    if (child(n)->visible())  return n + 1;
+  return 0;
+}
+
+
+bool
+Fl_Tabs::msaa_tabs_name(long id, BSTR* bstr)
+{
+  return Fl_Group::msaa_name(id + 1, bstr);
+}
+
+
+long
+Fl_Tabs::msaa_tabs_state(long id)
+{
+  long state = Fl_Group::msaa_state(0) & ~STATE_SYSTEM_FOCUSED;
+  if (id)
+  {
+    state |= (STATE_SYSTEM_SELECTABLE | STATE_SYSTEM_FOCUSABLE);
+    if (id == msaa_tabs_selected_id())
+    {
+      state |= STATE_SYSTEM_SELECTED;
+      if (Fl::focus() == this)  state |= STATE_SYSTEM_FOCUSED;
+    }
+  }
+  return state;
+}
+
+
+bool
+Fl_Tabs::msaa_tabs_shortcut(long id, BSTR* bstr)
+{
+  return Fl_Group::msaa_shortcut(id + 1, bstr);
+}
+
+
+bool
+Fl_Tabs::msaa_tabs_help(long id, BSTR* bstr)
+{
+  return Fl_Group::msaa_help(id + 1, bstr);
+}
+
+
+bool
+Fl_Tabs::msaa_tabs_location(long id, long* X, long* Y, long* W, long* H)
+{
+  if (!Fl_Group::msaa_location(0, X, Y, W, H))  return false;
+  int tab_h = tab_height();
+  if (tab_h >= 0)  *H = tab_h + Fl::box_dy(box());
+  else
+  {
+    *H = Fl::box_dy(box()) - tab_h;
+    *Y += (h() - tab_h);
+  }
+  if (id == 0)  return true;
+
+  // Find location of required tab button
+  int p[128];
+  int wp[128];
+  tab_positions(p, wp);
+  *X += p[id - 1];
+  *W  = wp[id - 1];
+  return true;
+}
+
+
+void
+Fl_Tabs::msaa_on_focus()
+{
+  // Focusing Fl_Tabs widget means active tab button is focused 
+  int id = msaa_tabs_selected_id();
+  if (!id)  return;
+  msaa_tabs_on_focus(id);
+}
+#endif // FL_HAVE_MSAA
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Text_Editor.cxx
===================================================================
--- src/Fl_Text_Editor.cxx	(revision 6732)
+++ src/Fl_Text_Editor.cxx	(working copy)
@@ -498,6 +498,9 @@
       if (buffer()->selected()) redraw(); // Redraw selections...
     case FL_HIDE:
       if (when() & FL_WHEN_RELEASE) maybe_do_callback();
+#ifdef FL_HAVE_MSAA
+      msaa_hide_caret();
+#endif // FL_HAVE_MSAA
       return 1;
 
     case FL_KEYBOARD:
Index: src/Fl_Input_.cxx
===================================================================
--- src/Fl_Input_.cxx	(revision 6732)
+++ src/Fl_Input_.cxx	(working copy)
@@ -298,6 +298,10 @@
 	x1 += (float)expandpos(p, pp, buf, &offset1);
 	fl_draw(buf, offset1, xpos, (float)(Y+ypos+desc));
       }
+#ifdef FL_HAVE_MSAA
+      if ((pp >= p) && (position() == selstart))
+        msaa_show_caret((int)(x1-1), Y+ypos, 2, height);
+#endif // FL_HAVE_MSAA
       pp = value()+selend;
       float x2 = (float)(X+W);
       int offset2;
@@ -311,6 +315,10 @@
 	fl_color(tc);
 	fl_draw(buf+offset2, strlen(buf+offset2), x2, (float)(Y+ypos+desc));
       }
+#ifdef FL_HAVE_MSAA
+      if ((pp <= e) && (position() == selend))
+        msaa_show_caret((int)(x2-1), Y+ypos, 2, height);
+#endif // FL_HAVE_MSAA
     } else {
       // draw unselected text
       fl_color(tc);
@@ -331,6 +339,9 @@
       } else {
         fl_rectf((int)(xpos+curx+0.5), Y+ypos, 2, height);
       }
+#ifdef FL_HAVE_MSAA
+      msaa_show_caret((int)(xpos+curx+0.5), Y+ypos, 2, height);
+#endif // FL_HAVE_MSAA
     }
 
   CONTINUE:
@@ -811,6 +822,9 @@
     fl_reset_spot();
     if (!readonly() && (when() & FL_WHEN_RELEASE))
       maybe_do_callback();
+#ifdef FL_HAVE_MSAA
+    msaa_hide_caret();
+#endif // FL_HAVE_MSAA
     return 1;
 
   case FL_PUSH:
@@ -983,6 +997,9 @@
     minimal_update(0);
   }
   position(readonly() ? 0 : size());
+#ifdef FL_HAVE_MSAA
+  msaa_input_on_change();
+#endif // FL_HAVE_MSAA
   return 1;
 }
 
@@ -1022,6 +1039,56 @@
   if (bufsize) free((void*)buffer);
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+void
+Fl_Input_::msaa_input_on_change()
+{
+  msaa_notify(EVENT_OBJECT_VALUECHANGE);
+}
+
+
+long
+Fl_Input_::msaa_role(long id)
+{
+  if (id != 0)  return Fl_Widget::msaa_role(id);
+  return ROLE_SYSTEM_TEXT;
+}
+
+
+bool
+Fl_Input_::msaa_value(long id, BSTR* bstr)
+{
+  if (id != 0)  return false;
+  if (input_type() != FL_SECRET_INPUT)
+    fl_str_to_bstr(value(), -1, bstr);
+  else
+  {
+    int   len = size();
+    char* s = (char*)malloc(len);
+    memset(s, '*', len);
+    fl_str_to_bstr(s, len, bstr);
+    fl_free_str(s);
+  }
+  return true;
+}
+
+
+bool 
+Fl_Input_::msaa_put_value(long id, const char* str)
+{
+  if (id != 0)  return false;
+  value(str);
+  return true;
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
